;===========================================================================================
; Cursor_1.asm  GoAsm assembler
; Nouveau curseur
; Programm par AsmGges France
; Charger un curseur depuis un fichier (le fichier .cur est indpendant du fichier .exe)
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\cursor_1.rc
; ..\..\bin\GoAsm cursor_1.asm
; ..\..\bin\GoLink cursor_1.obj res\cursor_1.res user32.dll kernel32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE = 17

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur depuis un fichier
    ; -----------------------------------------
    invoke LoadCursorFromFile,addr CursorFile
    mov [wc.hCursor],eax                    ;handle du curseur

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr Title,\
                          WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Active le curseur
    ; -----------------
    invoke SetCursor,[wc.hCursor]

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,addr msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,addr msg

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.defwindowproc
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:
    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  Title      db ' Charger un curseur depuis un fichier',0
  ClassName  db ' AsmGges Win32',0
  MsgEnd     db ' GoAsm AsmGges France @2006  ',0
  CursorFile db 'res\cursor.cur',0
  align 4

  WinX       dd 0
  WinY       dd 0
  WinW       dd 512
  WinH       dd 352

  hWnd       dd ?
  wc         WNDCLASS  < 0,addr WindowProc,0,0,NULL,NULL,NULL,\
                         COLOR_WINDOW+1,NULL,ClassName >
  msg        MSG       <>

;===========================================================================================
